			.mmregs ; positionnement des registres par defaut, aux adresses memoires
			.def _start
			.global	adr_debut_dat, adr_fin_dat, adr_coef,_start
			.global	adr_coef

			.sect	".coef"
adr_coef	.word	0X400				
		.word	0X400,0X400,0X400,0X400,0X400
		.word	0X400,0X400,0X400,0X400,0X400
		.word	0X400,0X400,0X400,0X400,0X400   ; 0X400 = 1/32 en mode fractionnaire ....
		
N			.set	16					; 16  --> N
			.bss 	adr_debut_dat,N+1	; allocation @adr_debut_dat de N+1 word
adr_fin_dat	.set 	adr_debut_dat+N-1   ; adr_debut_dat+N-1 --> adr_fin_dat 
			.bss	in,1				; 1 word pour in
			.bss	out,1				; 1 word pour out

			.text
* Initialisation de DP  0 et de FRCT  1
_start:		LD	#0, DP	  ; 0 --> DP		         
			SSBX	FRCT  ; Fractional Mode -> left shifting of the multiplier  

* Initialisation de AR0 et AR1 
			STM	#(adr_debut_dat),AR2    ;  (adr_debut_dat) --> AR2
			STM	#(adr_fin_dat),AR1  	;  (adr_fin_dat) --> AR1, STM = constante vers memory mapped register ou memoire donne page 0
			STM	#N, AR0					;	N --> AR0
			
* Init de la zone memoire  0			
			RPTZ	A, #N-1				;  0 --> A, N --> RC  (repette N fois l'instruction suivante)
				STL A, *AR2+
			STM	#(adr_debut_dat),AR2    ;  (adr_debut_dat) --> AR2, remise au debut
			
			
* Boucle sans fin
debut:
* Initialisation de AR1
			STM	#(adr_fin_dat),AR1 		; (adr_fin_dat) --> AR1

* Lecture de x(n)  l'adresse DRR  partir du fichier firin.dat
			LD	*(in), A 				; *in --> A
            STL	A,*AR2					; A --> *AR2

* Boucle de filtrage
			RPTZ	A, #N-1				;  0 --> A, N --> RC  (repette N fois l'instruction suivante)
				MACD	*AR1-, adr_coef, A  ;  PAR = 0; (*AR1)*adr_coef[PAR++] + A --> A; *AR1 --> *(AR1 +1) ; AR1--; 

* Sauvegarde de l'accumulateur dans la case tampon 
*  l'adress adr_fin_dat+1 puis sortie de y(n) dans fichier outfir.dat
			STH	A,*(out)				; A --> *out
		
* Retour au dbut de la boucle sans fin
			B	debut

* Autre filtre: 794,1082,-4324,-8214,3530,14264,3530,-8214,-4324,1082,794  
	